package dev.shadowsoffire.apotheosis.garden;

import net.minecraft.world.level.block.state.properties.BambooLeaves;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.util.RandomSource;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.StateDefinition;
import dev.shadowsoffire.placebo.util.IReplacementBlock;
import net.minecraft.world.level.block.BambooStalkBlock;

public class ApothBambooBlock extends BambooStalkBlock implements IReplacementBlock
{
    protected StateDefinition<Block, BlockState> container;
    
    public ApothBambooBlock() {
        super(BlockBehaviour.Properties.m_60926_((BlockBehaviour)Blocks.f_50571_));
    }
    
    public void m_213898_(final BlockState state, final ServerLevel worldIn, final BlockPos pos, final RandomSource random) {
        if ((int)state.m_61143_((Property)ApothBambooBlock.f_260694_) == 0 && random.m_188503_(3) == 0 && worldIn.m_46859_(pos.m_7494_()) && worldIn.m_45524_(pos.m_7494_(), 0) >= 9) {
            final int i = this.m_261132_((BlockGetter)worldIn, pos) + 1;
            if (i < GardenModule.maxBambooHeight) {
                this.m_261305_(state, (Level)worldIn, pos, random, i);
            }
        }
    }
    
    public boolean m_7370_(final LevelReader worldIn, final BlockPos pos, final BlockState state, final boolean isClient) {
        final int i = this.m_261076_((BlockGetter)worldIn, pos);
        final int j = this.m_261132_((BlockGetter)worldIn, pos);
        return i + j + 1 < GardenModule.maxBambooHeight && (int)worldIn.m_8055_(pos.m_6630_(i)).m_61143_((Property)ApothBambooBlock.f_260694_) != 1;
    }
    
    public void m_214148_(final ServerLevel worldIn, final RandomSource rand, final BlockPos pos, final BlockState state) {
        int bambooAbove = this.m_261076_((BlockGetter)worldIn, pos);
        final int bambooBelow = this.m_261132_((BlockGetter)worldIn, pos);
        int bambooSize = bambooAbove + bambooBelow + 1;
        for (int l = 1 + rand.m_188503_(2), i1 = 0; i1 < l; ++i1) {
            final BlockPos blockpos = pos.m_6630_(bambooAbove);
            final BlockState blockstate = worldIn.m_8055_(blockpos);
            if (bambooSize >= GardenModule.maxBambooHeight || (int)blockstate.m_61143_((Property)ApothBambooBlock.f_260694_) == 1 || !worldIn.m_46859_(blockpos.m_7494_())) {
                return;
            }
            this.m_261305_(blockstate, (Level)worldIn, blockpos, rand, bambooSize);
            ++bambooAbove;
            ++bambooSize;
        }
    }
    
    protected int m_261076_(final BlockGetter worldIn, final BlockPos pos) {
        int i;
        for (i = 0; i < GardenModule.maxBambooHeight && worldIn.m_8055_(pos.m_6630_(i + 1)).m_60734_() == Blocks.f_50571_; ++i) {}
        return i;
    }
    
    protected int m_261132_(final BlockGetter worldIn, final BlockPos pos) {
        int i;
        for (i = 0; i < GardenModule.maxBambooHeight && worldIn.m_8055_(pos.m_6625_(i + 1)).m_60734_() == Blocks.f_50571_; ++i) {}
        return i;
    }
    
    protected void m_261305_(final BlockState blockStateIn, final Level worldIn, final BlockPos posIn, final RandomSource rand, final int size) {
        final BlockState blockstate = worldIn.m_8055_(posIn.m_7495_());
        final BlockPos blockpos = posIn.m_6625_(2);
        final BlockState blockstate2 = worldIn.m_8055_(blockpos);
        BambooLeaves bambooleaves = BambooLeaves.NONE;
        if (size >= 1) {
            if (blockstate.m_60734_() == Blocks.f_50571_ && blockstate.m_61143_((Property)ApothBambooBlock.f_260716_) != BambooLeaves.NONE) {
                if (blockstate.m_60734_() == Blocks.f_50571_ && blockstate.m_61143_((Property)ApothBambooBlock.f_260716_) != BambooLeaves.NONE) {
                    bambooleaves = BambooLeaves.LARGE;
                    if (blockstate2.m_60734_() == Blocks.f_50571_) {
                        worldIn.m_7731_(posIn.m_7495_(), (BlockState)blockstate.m_61124_((Property)ApothBambooBlock.f_260716_, (Comparable)BambooLeaves.SMALL), 3);
                        worldIn.m_7731_(blockpos, (BlockState)blockstate2.m_61124_((Property)ApothBambooBlock.f_260716_, (Comparable)BambooLeaves.NONE), 3);
                    }
                }
            }
            else {
                bambooleaves = BambooLeaves.SMALL;
            }
        }
        final int i = ((int)blockStateIn.m_61143_((Property)ApothBambooBlock.f_260603_) == 1 || blockstate2.m_60734_() == Blocks.f_50571_) ? 1 : 0;
        final int j = ((size >= GardenModule.maxBambooHeight - GardenModule.maxBambooHeight / 5.0 && rand.m_188501_() < 0.25f) || size == GardenModule.maxBambooHeight - 1) ? 1 : 0;
        worldIn.m_7731_(posIn.m_7494_(), (BlockState)((BlockState)((BlockState)this.m_49966_().m_61124_((Property)ApothBambooBlock.f_260603_, (Comparable)i)).m_61124_((Property)ApothBambooBlock.f_260716_, (Comparable)bambooleaves)).m_61124_((Property)ApothBambooBlock.f_260694_, (Comparable)j), 3);
    }
    
    public void _setDefaultState(final BlockState state) {
        this.m_49959_(state);
    }
    
    public void setStateContainer(final StateDefinition<Block, BlockState> container) {
        this.container = container;
    }
    
    public StateDefinition<Block, BlockState> m_49965_() {
        return (StateDefinition<Block, BlockState>)((this.container == null) ? super.m_49965_() : this.container);
    }
}
